=== lib/Optimizer/Transforms/CMakeLists.txt ===
add_flang_library(FIRTransforms
  AbstractResult.cpp
  AffinePromotion.cpp
  AffineDemotion.cpp
  AnnotateConstant.cpp
  CharacterConversion.cpp
  ControlFlowConverter.cpp
  ArrayValueCopy.cpp
  ExternalNameConversion.cpp
  MemoryAllocation.cpp
  StackArrays.cpp
  MemRefDataFlowOpt.cpp
  SimplifyRegionLite.cpp
  AlgebraicSimplification.cpp
  SimplifyIntrinsics.cpp
  AddDebugFoundation.cpp
  PolymorphicOpConversion.cpp
  LoopVersioning.cpp
  OMPEarlyOutlining.cpp
  OMPFunctionFiltering.cpp
  OMPMarkDeclareTarget.cpp

  DEPENDS
  FIRDialect
  FIROptTransformsPassIncGen
  HLFIROpsIncGen

  LINK_LIBS
  FIRBuilder
  FIRCodeGen
  FIRDialect
  FIRDialectSupport
  FIRSupport
  HLFIRDialect
  MLIRAffineUtils
  MLIRFuncDialect
  MLIRLLVMDialect
  MLIRLLVMCommonConversion
  MLIRMathTransforms
  MLIROpenACCDialect
  MLIROpenACCToLLVMIRTranslation
  MLIROpenMPDialect
)
